/* mdump_help.c */

static char rcsid[] = "$Id: mdump_help.c,v 1.2 1994/07/31 10:38:58 JACK Exp $";

#include	<stdio.h>
#include	<string.h>
#include	<sys/dos.h>

#include	"mdump.h"
#include	"twin.h"

#ifndef	MAX_LIST
#define	MAX_LIST	1024
#endif

/* G[\Tu[` */
extern void print_error(char *);

/* IOCS x̃L[̓Tu[`̐錾 */
extern int key_in(void);
extern void key_flush(void);
extern int key_wait(void);

/* j[Xgp\ */
struct menu_list {
	char **menu;
	char **data;
	int max_list;
	int max;
	int offset;
	int pos;
};

/* possڂĕ\ */
int menu_line(TWIN *win, struct menu_list *list, int pos)
{
	twinlocate(win, 0, pos);
	twinprint(win, "\x1b[2K");
	if (list->offset+pos < list->max) {
		twinprint(win, list->menu[list->offset+pos]);
	}
	if (list->offset+pos+1 >= list->max) {
		/* ̃XgȂ */
		return 1;
	}
	return 0;
}

/* XN[͈͂ɃXg\ */
void menu_all(TWIN *win, struct menu_list *list)
{
	int i;

	for (i = 0;i < win->tymax+1; i++) {
		if (menu_line(win, list, i) != 0) {
			if (i < win->tymax) {
				/* ]NA */
				twinlocate(win, 0, i+1);
				twinprint(win, "\x1b[0J");
			}
			break;
		}
	}
}

void menu_page_top(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos == 0) {
		/* ߂KvȂ */
		return;
	}

	/* Sʕ\ */
	list->offset = 0;
	list->pos = 0;
	menu_all(win, list);
}

void menu_page_end(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos+1 == list->max) {
		/* ߂KvȂ */
		return;
	}

	/* Sʕ\ */
	if (list->max >= win->tymax+1) {
		list->offset = list->max - (win->tymax+1);
		list->pos = win->tymax;
	} else {
		/* Sʖ܂Ȃ */
		list->offset = 0;
		list->pos = list->max-1;
	}
	menu_all(win, list);
}

void menu_page_up(TWIN *win, struct menu_list *list)
{
	if (list->offset+(win->tymax+1)+win->tymax >= list->max) {
		/* y[WAbvłȂ̂ōŌɍs */
		menu_page_end(win, list);
		return;
	}

	/* Sʕ\ */
	list->offset += win->tymax+1;
	menu_all(win, list);
}

void menu_page_down(TWIN *win, struct menu_list *list)
{
	if (list->offset-(win->tymax+1) < 0) {
		/* y[W_EłȂ̂Ő擪ɍs */
		menu_page_top(win, list);
		return;
	}

	/* Sʕ\ */
	list->offset -= win->tymax+1;
	menu_all(win, list);
}

void menu_roll_up(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos+1 >= list->max) {
		/* ̃XgȂ */
		return;
	}

	/* VKs̕\ */
	if (list->pos+1 <= win->tymax) {
		list->pos++;
	} else {
		/* GXP[vV[PXłPsXN[Abv */
		twinlocate(win, 0, win->tymax);
		twinprint(win, "\x1b""D");

		list->offset++;
		menu_line(win, list, list->pos);
	}
}

void menu_roll_down(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos-1 < 0) {
		/* ̃XgȂ */
		return;
	}

	/* VKs̕\ */
	if (list->pos-1 >= 0) {
		list->pos--;
	} else {
		/* GXP[vV[PXłPsXN[_E */
		twinlocate(win, 0, 0);
		twinprint(win, "\x1b""M");

		list->offset--;
		menu_line(win, list, list->pos);
	}
}

#define	KEY_NULL	0x0000
#define	KEY_RUP		0x0001
#define	KEY_RDOWN	0x0002
#define	KEY_CRUP	0x0101
#define	KEY_CRDOWN	0x0102
#define	KEY_UP		0x0004
#define	KEY_DOWN	0x0008
#define	KEY_LEFT	0x0010
#define	KEY_RIGHT	0x0011
#define	KEY_ESC		0x0020
#define	KEY_HELP	0x0040

int mdump_help_key_in(void)
{
	int c, s;

	c = key_in();
	s = _iocs_b_sftsns();

	switch (c) {
	case 0x011b:
		/* ESC */
	case 0x3a00:
		/* UNDO */
		return KEY_ESC;
	case 0x3800:
		/* ROLL UP */
		if (s & 0x02)	return KEY_CRUP;
		return KEY_RUP;
	case 0x3900:
		/* ROLL DOWN */
		if (s & 0x02)	return KEY_CRDOWN;
		return KEY_RDOWN;
	case 0x3b00:
		/*  */
		return KEY_LEFT;
	case 0x3c00:
		/*  */
		return KEY_UP;
	case 0x3d00:
		/* E */
		return KEY_RIGHT;
	case 0x3e00:
		/*  */
		return KEY_DOWN;
	case 0x5400:
		/* HELP */
		return KEY_HELP;
	case 0:
		/* ͂Ȃ */
	default:
		return KEY_NULL;
	}
	return KEY_NULL;
}

int read_menu_list(struct menu_list *list, char *file)
{
	static char buffer[MAX_LINE_SIZE+1];
	FILE *fp;
	int lines;

	if ((fp = fopen(file, "rt")) == NULL) {
		sprintf(buffer, "%s ܂.", file);
		print_error(buffer);
		return 0;
	}

	for (lines = 1; list->max < list->max_list; lines++) {
		if (fgets(buffer, MAX_LINE_SIZE, fp) == NULL) break;
		buffer[strlen(buffer)-1] = '\0';
		list->menu[list->max] =xstrdup(buffer);
		list->max++;
	}
	fclose(fp);

	return list->max;
}

void mdump_help(void)
{
	TWIN *win;
	short x, y, wx = 64, wy = 16;
	short col = 1, fsize = 16;
	short type = WIN_MINT;
	short pcol = 3;
	short tcol = col+0x08;

	static char *menu_list[MAX_LIST];
	struct menu_list *list;

	int c;

	struct _psp *my_psp;
	char help_file[MAX_PATH_LEN];

	my_psp = _dos_getpdb();
	strcpy(help_file, my_psp->exe_path);
	strcat(help_file, my_psp->exe_name);
	suppress_extension(help_file);
	strcat(help_file, ".hlp");

	list = xmalloc(sizeof(struct menu_list));
	list->menu = menu_list;
	list->data = NULL;
	list->max_list = MAX_LIST;
	list->max = 0;
	list->offset = 0;
	list->pos = 0;

	if (read_menu_list(list, help_file) == 0) {
		/* XgPLłȂ */
		xfree(list);
		return;
	}

	/* tHgTCYlăZ^O */
	x = (768/(fsize/2)/2) - ((wx+2)/2);
	y = ((16*24)/fsize/2) - ((wy+2)/2);

	/* EBhE|C^mۂ */
	win = twinopen(x, y, wx, wy, col, fsize);
	win->tbufp = xmalloc(twinworksize(win));

	/* EBhE\ */
	twindraw(win, type, "\\Cmdump help", tcol);

	/* bZ[W\Fݒ */
	twincolor(win, pcol);

	/* Ƃ肠Sʕ\ */
	menu_all(win, list);

	/* L[̓obt@NA */
	key_flush();

	while (1) {
		c = mdump_help_key_in();
		switch (c) {
			case KEY_ESC:
			case KEY_HELP:
				/* ESC, UNDO, HELP */
				c = -1;
				goto loop_exit;

			case KEY_CRUP:
				/* CTRL + ROLL UP */
				key_flush();
				menu_page_end(win, list);
				break;
			case KEY_CRDOWN:
				/* CTRL + ROLL DOWN */
				key_flush();
				menu_page_top(win, list);
				break;

			case KEY_RUP:
				/* ROLL UP */
				key_flush();
				menu_page_up(win, list);
				break;
			case KEY_RDOWN:
				/* ROLL DOWN */
				key_flush();
				menu_page_down(win, list);
				break;

			case KEY_UP:
				/*  */
				key_flush();
				menu_page_down(win, list);
				break;
			case KEY_DOWN:
				/*  */
				key_flush();
				menu_page_up(win, list);
				break;

			case KEY_NULL:
			default:
				/* ͂Ȃ */
				break;
		}
	}

/* ESC L[ */
loop_exit:
	/* L[̓obt@NA */
	key_flush();

#ifdef TEST
	{
		void *p;
		int i;

		i = 0;
		while ((p = malloc(i)) != NULL) {
			free(p);
			i += 128;
		}
		printf("%d Byte cĂ܂.\n", i);
	}
#endif

	/* n */
	twinclear(win);
	xfree(win->tbufp);
	twinclose(win);

	while (list->max >= 0) {
		list->max--;
		if (list->menu) xfree(list->menu[list->max]);
		if (list->data) xfree(list->data[list->max]);
	}
	xfree(list);
	return;
}
