/* mdump_main.c */

static char rcsid[] = "$Id: mdump_main.c,v 1.1 1994/07/30 05:49:23 JACK Exp $";

#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>
#include	<sys/dos.h>
#include	<sys/xglob.h>

#include	"mdump.h"
#include	"twin.h"

extern char ID_name[];
extern char ID_version[];
extern int mdump(char *);

/* core No. */
int TWINCORE_NO = -1;

/* ϐ SLASH ̒l */
char SLASH;

/* XCb`w */
int CODE = 0;
int MODE = 0;
int OFFSET = 0;
int MAXREADSIZE = 0;
int opt_a = 0;
int opt_r = 0;
int opt_d = 0;

/* ύXÕu[N`FbN̒l */
int break_flag = -1;

/* g̖O */
char *progname;

/* XbVݒQƂ */
static void set_slash(void)
{
	char *p;

	if((p = getenv("SLASH")) != NULL)
		SLASH = *p;
	else
		SLASH = '\\';
}

/* XbV𓝈ꂷ */
void toslash(char *str)
{
	if(SLASH == '/')
		_toslash(str);
	else
		_tobslash(str);
}

/* x[Xl[߂ */
char *get_basename(char *fname)
{
	char *p;

	if ((p = strrchr(fname, ':')) != NULL)	fname = p + 1;
	if ((p = strrchr(fname, '/')) != NULL)	fname = p + 1;
	if ((p = strrchr(fname, '\\')) != NULL)	fname = p + 1;
	return fname;
}

/* gqׂ */
char *suppress_extension(char *fname)
{
	int len;

	/* .x .X .r .R .z .Z ׂ */
	if ((len = strlen(fname)) > 2) {
		if (fname[len-2] == '.') {
			switch (fname[len-1]) {
				case 'x':
				case 'X':
				case 'r':
				case 'R':
				case 'z':
				case 'Z':
					fname[len-2] = '\0'; break;
			}
		}
	}
	return fname;
}

/* u[N`FbN̐ݒ߂ */
void reset_breakcheck(void)
{
	if (break_flag != -1) {
		_dos_breakck(break_flag);
		break_flag = -1;
	}
}

/* u[N`FbN̐ݒ OFF ɂ */
void set_breakcheck(void)
{
	atexit(reset_breakcheck);
	break_flag = _dos_breakck(-1);
	_dos_breakck(0);
}

void *xmalloc(size_t size)
{
	void *p;

	if (p = malloc(size))	return p;
	perror(NULL);
	exit(EXIT_ERROR);
}

void xfree(void *p)
{
	if (p)	free(p);
}

char *xstrdup(char *str)
{
	char *p;

	if (p = strdup(str))	return p;
	perror(NULL);
	exit(EXIT_ERROR);
}

long str2long(char *str, char **endptr)
{
	int radix = 0;

	if (str[0] == '$') {
		str++;
		radix = 16;
	} else if (str[0] == '0' && (str[1] == 'b' || str[1] == 'B')) {
		str += 2;
		radix = 2;
	}
	return strtol(str, endptr, radix);
}

void ID_print(void)
{
	fprintf(stderr, "%s %s (c) JACK\n", ID_name, ID_version);
}

void version(void)
{
	fprintf(stderr, "%s %s (c) JACK\n", progname, ID_version);
}

void usage(void)
{
	fprintf(stderr, "usage: %s [-ardhV] [-m mode] [-c code] [-o offset] [-s size] <file> \n", progname);
}

void help(void)
{
	static char *help_message[] = {
		" -m mode   \[h",
		" -c code   \R[h",
		" -o offset ItZbgʒu",
		" -s size   őǂݍ݃TCY",
		" -a        mۂłőTCYɂ",
		" -r        t@Cǂ݂",
		" -d        Wo͂ɏo",
		" -h        wv\",
		" -V        o[W\",
		NULL
	};
	char **p = help_message;

	version();
	usage();
	while (*p)	fprintf(stderr, "%s\n", *p++);
}

int getarg(int argc, char *argv[], char *file[])
{
	int i, j;
	char *e;

	for (i = 1, j = 0; i < argc; i++) {
		if (*argv[i] == '-') {
			while (*++argv[i]) {
				switch(*argv[i]) {
					case	'm':
						if (*++argv[i] == '\0' && i++ >= argc) {
							printf("\[hw肵Ă.\n");
							exit(EXIT_ERROR);
						}
						MODE = str2long(argv[i], &e);
						if (*e || MODE < 0 || MODE > 1) {
							printf("w肳ꂽlُł.\n");
							exit(EXIT_ERROR);
						}
						argv[i] = --e;
						break;
					case	'c':
						if (*++argv[i] == '\0' && i++ >= argc) {
							printf("\R[hw肵Ă.\n");
							exit(EXIT_ERROR);
						}
						CODE = str2long(argv[i], &e);
						if (*e || CODE < 0 || CODE > 2) {
							printf("w肳ꂽlُł.\n");
							exit(EXIT_ERROR);
						}
						argv[i] = --e;
						break;
					case	'o':
						if (*++argv[i] == '\0' && i++ >= argc) {
							printf("ItZbgTCYw肵Ă.\n");
							exit(EXIT_ERROR);
						}
						OFFSET = str2long(argv[i], &e);
						if (*e || OFFSET < 0) {
							printf("w肳ꂽlُł.\n");
							exit(EXIT_ERROR);
						}
						argv[i] = --e;
						break;
					case	's':
						if (*++argv[i] == '\0' && i++ >= argc) {
							printf("ǂݍ݃TCYw肵Ă.\n");
							exit(EXIT_ERROR);
						}
						MAXREADSIZE = str2long(argv[i], &e);
						if (*e || MAXREADSIZE < 0) {
							printf("w肳ꂽlُł.\n");
							exit(EXIT_ERROR);
						}
						argv[i] = --e;
						break;
					case	'a':
						opt_a = 1; break;
					case	'r':
						opt_r = 1; break;
					case	'd':
						opt_d = 1; break;
					case	'V':
						ID_print(); exit(EXIT_OK); break;
					case	'h':
						help(); exit(EXIT_ERROR); break;
					default:
						usage(); exit(EXIT_ERROR); break;
				}
			}
		} else {
			file[j++] = argv[i];
		}
	}
	return j;
}

void core_end(void)
{
	if (TWINCORE_NO != -1) {
		/* twincore ̏I錾 */
		twinend(TWINCORE_NO);
		TWINCORE_NO = -1;
	}
}

int main(int argc, char *argv[])
{
	char *files[128];
	char cur_path[PATH_MAX+1];
	char file[PATH_MAX+1];
	char drv[3];
	char path[128];
	char node[23];
	char ext[23];
	char *p;
	int i;

	/* vO̐ݒ */
	progname = xstrdup(get_basename(argv[0]));
#ifdef	SUPPRESS_EXTENSION
	suppress_extension(progname);
#endif

	/* XbVݒ */
	set_slash();

	/* u[N`FbN̐ݒ */
	set_breakcheck();

	/* ݂̃Jg𓾂 */
	getcwd(cur_path, PATH_MAX);

	if ((i = getarg(argc, argv, files)) > 128) {
		printf("p[^߂܂.\n");
		exit(EXIT_ERROR);
	}
	if (i == 0) {
		printf("t@Cw肵Ă.\n");
		usage();
		exit(EXIT_ERROR);
	}

	/* Nt@Cœ */
	if (!opt_d) {
		strsfn(argv[0], drv, path, node, ext);
		if (strcmp(node, "dump") == 0) {
			opt_r = 1;
			opt_d = 1;
		}
	}

	if (i > 0) {
		if (files[0][1] == ':') {
			/* hCuw肳Ă */
			strcpy(file, files[0]);
		} else if ((files[0][0] == '/' || files[0][0] == '\\') &&
			((p = getenv("SYSROOT")) != NULL)) {
			/* SYSROOT QƂ */
			strcpy(file, p);
			p = file + strlen(file) - 1;
			if (*p == '/' || *p == '\\') {
				/* SYSROOT = A:/ */
				strcat(file, (files[0]+1));
			} else {
				/* SYSROOT = A:/foo */
				strcat(file, files[0]);
			}
		} else {
			/* SYSROOT ȂꍇA܂́A擪 / or \ łȂ
			   JghCut */
			file[0] = cur_path[0];
			file[1] = cur_path[1];
			file[2] = '\0';
			strcat(file, files[0]);
		}
	}
	toslash(file);

	/* twincore ̃`FbNJn錾 */
	if ((TWINCORE_NO = twininit()) < 0) {
		printf("twincorepł܂\n");
		exit(EXIT_ERROR);
	}
	/* ItwinendȂǂs */
	atexit(core_end);

	twinblinkon();

	_iocs_b_curoff();
	mdump(file);
	_iocs_b_curon();

	twinblinkoff();
	return 0;
}
